Syncfusion AI Assistant

How can I help you?

Create dual list in EJ2 JavaScript ListView Control

5 Mar 202519 minutes to read

The dual list configuration involves two ListView controls, allowing for list items to be transferred between lists using client-side events. This section explains how to integrate ListView controls to achieve a dual list.

Use cases

Dual lists can be utilized in scenarios such as:

  • Stock exchanges of two different countries.
  • Job applications (skill sets).

Integration of Dual List

To implement a dual list, two ListView controls are used to display items. The interface uses an ej2-button for transferring data between lists and a textbox for filtering support.

Key features of the dual list include:

  • Transferring all items from one list to another.
  • Transferring selected items from one list to another.
  • Filtering lists using input from a textbox.

In the ListView control, sorting is enabled using the sortOrder property, and the select event is triggered when an item is selected. The select event manages the enabling and disabling of buttons based on the item selection.

Manipulating data

Moving entire data from the first list to the second list (>>)

All items can be transferred from the first ListView to the second by clicking the designated button. When clicked, all items from the first list are concatenated with the second ListView’s data source. This button is active only when the first ListView has items.

Moving entire data From the second list to the first list (<<)

This button performs the reverse action, transferring all items from the second ListView to the first. It is active only when the second ListView has items.

Transferring selected items (> and <)

The Select event facilitates transferring selected items between lists. These buttons are enabled when an item is selected in either list.

Filtering method

A filtering method allows you to filter list items by typing characters into a textbox. This feature utilizes the dataManager to fetch and display filtered data in the ListView.

Sorting

Using the dual list, list items can be sorted in the ListView using the sortOrder property. Enabling sorting in one ListView allows the data to be transferred in the same order to the other ListView.

//Define an array of JSON data
var firstListData = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },

];

var secondListData = [
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
];


// Initialize the ListView component
var listObj1 = new ej.lists.ListView({

    //Set the defined data to the dataSource property
    dataSource: firstListData.slice(),

    //Map the appropriate columns to the fields property
    fields: { text: 'text', id: 'id' },
    sortOrder: 'Ascending',
    select: onFirstListSelect

});

//Render the initialized ListView component
listObj1.appendTo('#list-1');

var listObj2 = new ej.lists.ListView({

    //Set the defined data to the dataSource property
    dataSource: secondListData.slice(),

    //Map the appropriate columns to the fields property
    fields: { text: 'text', id: 'id' },
    sortOrder: 'Ascending',
    select: onSeconListSelect

});

//Render the initialized ListView component
listObj2.appendTo('#list-2');

var btnobj1 = new ej.buttons.Button();
btnobj1.appendTo('#firstBtn');

var btnobj2 = new ej.buttons.Button({
    disabled: true
});
btnobj2.appendTo('#secondBtn');

var btnobj3 = new ej.buttons.Button({
    disabled: true
});
btnobj3.appendTo('#thirdBtn');

var btnobj4 = new ej.buttons.Button();
btnobj4.appendTo('#fourthBtn');


//Here, all list items are moved to the second list on clicking move all button
btnobj1.element.addEventListener('click', function () {
    listObj2.dataSource = Array.prototype.concat.call(listObj1.dataSource, listObj2.dataSource);
    listObj2.dataBind();
    updateFirstListData();
    listObj1.removeMultipleItems(Array.prototype.slice.call(listObj1.element.querySelectorAll('.e-list-item')));
    firstListData = firstListData.concat(listObj1.dataSource);
    secondListData = listObj2.dataSource.slice();
    btnobj1.disabled = true;
    onFirstKeyUp();
    setButtonState();
});

//Here, the selected list items are moved to the second list on clicking move button
btnobj2.element.addEventListener('click', function () {
    var selectedItem = listObj1.getSelectedItems();
    listObj2.dataSource = Array.prototype.concat.call(listObj2.dataSource, selectedItem.data);
    listObj2.dataBind();
    updateFirstListData();
    listObj1.removeItem(selectedItem.item);
    firstListData = firstListData.concat(listObj1.dataSource);
    secondListData = listObj2.dataSource.slice();
    onFirstKeyUp();
    btnobj2.disabled = true;
    setButtonState();
});

//Here, the selected list items are moved to the first list on clicking move button
btnobj3.element.addEventListener('click', function () {
    var selectedItem = listObj2.getSelectedItems();
    listObj1.dataSource = Array.prototype.concat.call(listObj1.dataSource, selectedItem.data);
    listObj1.dataBind();
    updateSecondListData();
    listObj2.removeItem(selectedItem.item);
    secondListData = secondListData.concat(listObj2.dataSource);
    firstListData = listObj1.dataSource.slice();
    onSecondKeyUp();
    btnobj3.disabled = true;
    setButtonState();

});

//Here, all list items are moved to the first list on clicking move all button
btnobj4.element.addEventListener('click', function () {
    listObj1.dataSource = Array.prototype.concat.call(listObj1.dataSource, listObj2.dataSource);
    listObj1.dataBind();
    updateSecondListData();
    listObj2.removeMultipleItems(Array.prototype.slice.call(listObj2.element.querySelectorAll('.e-list-item')));
    secondListData = secondListData.concat(listObj2.dataSource);
    firstListData = listObj1.dataSource.slice();
    onSecondKeyUp();
    setButtonState();

});

//Here, the ListView data source is updated to the first list
function updateFirstListData() {
    Array.prototype.forEach.call(listObj1.element.querySelectorAll('.e-list-item'), function (list) {
        firstListData.forEach(function (data, index) {
            if (list.innerText.trim() === data.text) {
                firstListData.splice(index, 1)
            }
        });
    });
    (document.getElementById("firstInput")).value = '';
    var ds = [];
    firstListData.forEach(function (data) {
        ds.push(data);
    })
    firstListData = ds;

}

//Here, the ListView dataSource is updated for the second list
function updateSecondListData() {
    Array.prototype.forEach.call(listObj2.element.querySelectorAll('.e-list-item'), function (list) {
        secondListData.forEach(function (data, index) {
            if (list.innerText.trim() === data.text) {
                secondListData.splice(index, 1)
            }
        });

    });
    document.getElementById("secondInput").value = '';
    var ds = [];
    secondListData.forEach(function (data) {
        ds.push(data);
    })
    secondListData = ds;

}
function onFirstListSelect() {
    btnobj2.disabled = false;
}
function onSeconListSelect() {
    btnobj3.disabled = false;
}
document.getElementById('firstInput').addEventListener('keyup', onFirstKeyUp);
//Here, filtering is handled using the dataManager for the first list
function onFirstKeyUp() {
    var value = document.getElementById("firstInput").value;
    var data = new ej.data.DataManager(firstListData).executeLocal(new ej.data.Query().where('text', 'startswith', value, true));
    if (!value) {
        listObj1.dataSource = firstListData.slice();
    } else {
        listObj1.dataSource = data;
    }
    listObj1.dataBind();

}
document.getElementById('secondInput').addEventListener('keyup', onSecondKeyUp);
//Here, filtering is handled using the dataManager for the second list
function onSecondKeyUp() {
    var value = document.getElementById("secondInput").value;
    var data = new ej.data.DataManager(secondListData).executeLocal(new ej.data.Query().where('text', 'startswith', value, true));
    if (!value) {
        listObj2.dataSource = secondListData.slice();
    } else {
        listObj2.dataSource = data;
    }
    listObj2.dataBind();
}

//Here, the state of the button is changed
function setButtonState() {
    if (listObj1.dataSource.length) {
        btnobj1.disabled = false;
    } else {
        btnobj1.disabled = true;
        btnobj2.disabled = true;
    }

    if (listObj2.dataSource.length) {
        btnobj4.disabled = false;
    } else {
        btnobj4.disabled = true;
        btnobj3.disabled = true;
    }

}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 for ListView </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for ListView UI Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <h3>Dual List</h3>
        <div class="list_container">
            <div id="list_container_1">
                <input class="e-input" type="text" id="firstInput" placeholder="  Filter" title="Type in a name">
                <div id="list-1"></div>
            </div>
            <div id="btn">
                <button id="firstBtn"> &gt;&gt; </button>
                <button id="secondBtn"> &gt; </button>
                <button id="thirdBtn">
                    &lt; </button>
                <button id="fourthBtn">
                    &lt;&lt; </button>
            </div>
            <div id="list_container_2">
                <input class="e-input" type="text" id="secondInput" placeholder="  Filter" title="Type in a name">
                <div id="list-2"></div>
            </div>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        .list_container {
            height: 398px;
            max-width: 485px;
            margin: auto;
        }

        #list_container_1,
        #list_container_2 {
            width: 200px;
        }

        #list-1,
        #list-2 {
            height: 362px;
            border: 1px solid #dddddd;
            border-radius: 3px;
        }

        #list_container_1,
        #list_container_2 {
            display: inline-block;
        }

        .e-btn {
            margin-bottom: 15px;
            width: 40px;
            height: 40px;
        }

        #btn {
            display: inline-block;
            width: 41px;
            margin: 0 15px;
            position: relative;
            top: -53%;
            transform: translateY(50%);
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  top: 45%;
  left: 45%;
}

Create Dual List from ListView in React ListView Component

23 Jan 202524 minutes to read

The dual list contains two ListView components. This allows you to move list items from one list to another using client-side events. This section explains how to integrate the ListView component to achieve a dual list.

Use cases

  • Stock exchanges of two different countries
  • Job applications (skill sets)

Integration of Dual List

Here, two ListView components have been used to display the list items. An EJ2 Button is used to transfer data between the ListViews, and a textbox is used to achieve the UI of filtering support.

The dual list supports:

  • Moving whole data from one list to another.
  • Moving selected data from one list to another.
  • Filtering the list by using a client-side typed character.

In the ListView component, sorting is enabled using the sortOrder property, and the select event is triggered while selecting an item. Here, the select event is triggered to enable and disable button states.

Manipulating data

Moving whole data from the first list to the second list(»)

The entire data set can be moved from the first ListView to the second by clicking the first button. When clicking the button, all list items are sliced and connected with the second ListView. This button is enabled only when the data source of the first ListView is not empty.

Moving whole data from the second list to the first list(«)

The functionality of the second button is the same as above, but data is transferred from the second list to the first list. This button is enabled only when the data source of the second ListView is not empty.

Moving selected item from one list to another list (>) and (<)

The select event is triggered when selecting a list item in the ListView. The selected items can be transferred between two lists. These buttons will be enabled when selecting an item in lists.

Filtering method

The filtering method is used to filter list items when typing a character in the text box. In this method, the DataManager has been used to fetch data from the data source and display in ListView.

Sorting

List items can be sorted in the ListView component using the sortOrder property. You can enable sorting in one ListView; in the same order, data can be transferred to another ListView.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { DataManager, Query } from '@syncfusion/ej2-data';
import { enableRipple } from "@syncfusion/ej2-base";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import './index.css';

enableRipple(true);
function App() {
    React.useEffect(() => {
        componentDidMount();
    }, []);
    //Define an array of JSON data
    let firstListData = [
        { text: "Hennessey Venom", id: "list-01" },
        { text: "Bugatti Chiron", id: "list-02" },
        { text: "Bugatti Veyron Super Sport", id: "list-03" },
        { text: "SSC Ultimate Aero", id: "list-04" },
        { text: "Koenigsegg CCR", id: "list-05" },
        { text: "McLaren F1", id: "list-06" }
    ];
    let secondListData = [
        { text: "Aston Martin One- 77", id: "list-07" },
        { text: "Jaguar XJ220", id: "list-08" },
        { text: "McLaren P1", id: "list-09" },
        { text: "Ferrari LaFerrari", id: "list-10" }
    ];
    let firstInput = null;
    let secondInput = null;
    let listFirstInstance = null;
    let listSecondInstance = null;
    let firstBtnInstance = null;
    let secondBtnInstance = null;
    let thirdBtnInstance = null;
    let fourthBtnInstance = null;
    function componentDidMount() {
        if (listFirstInstance && listSecondInstance) {
            firstListData = listFirstInstance.dataSource.slice();
            secondListData = listSecondInstance.dataSource.slice();
        }
    }
    //Map the appropriate columns to fields property
    let fields = { text: "text", id: "id" };
    function onFirstListSelect() {
        if (secondBtnInstance)
            secondBtnInstance.disabled = false;
    }
    function onSecondListSelect() {
        if (thirdBtnInstance)
            thirdBtnInstance.disabled = false;
    }
    function updateFirstListData() {
        if (listFirstInstance) {
            Array.prototype.forEach.call(listFirstInstance.liCollection, (list) => {
                firstListData.forEach((data, index) => {
                    if (list.innerText.trim() === data.text) {
                        delete firstListData[index];
                    }
                });
            });
            if (firstInput) {
                firstInput.value = "";
            }
            let ds = [];
            firstListData.forEach(data => {
                ds.push(data);
            });
            firstListData = ds;
        }
    }
    function updateSecondListData() {
        Array.prototype.forEach.call(listSecondInstance.liCollection, (list) => {
            secondListData.forEach((data, index) => {
                if (list.innerText.trim() === data.text) {
                    delete secondListData[index];
                }
            });
        });
        if (secondInput) {
            secondInput.value = "";
        }
        let ds = [];
        secondListData.forEach(data => {
            ds.push(data);
        });
        secondListData = ds;
    }
    function onFirstKeyUp(e) {
        if (firstInput) {
            let value = firstInput.value;
            var data = new DataManager(firstListData).executeLocal(new Query().where("text", "startswith", value, true));
            if (listFirstInstance) {
                if (!value) {
                    listFirstInstance.dataSource = firstListData.slice();
                }
                else {
                    listFirstInstance.dataSource = data;
                }
                listFirstInstance.dataBind();
            }
        }
    }
    function onSecondKeyUp(e) {
        if (secondInput) {
            let value = secondInput.value;
            var data = new DataManager(secondListData).executeLocal(new Query().where("text", "startswith", value, true));
            if (listSecondInstance) {
                if (!value) {
                    listSecondInstance.dataSource = secondListData.slice();
                }
                else {
                    listSecondInstance.dataSource = data;
                }
                listSecondInstance.dataBind();
            }
        }
    }
    function setButtonState() {
        if (listFirstInstance &&
            firstBtnInstance &&
            secondBtnInstance &&
            listSecondInstance &&
            fourthBtnInstance &&
            thirdBtnInstance) {
            if (listFirstInstance.dataSource.length) {
                firstBtnInstance.disabled = false;
            }
            else {
                firstBtnInstance.disabled = true;
                secondBtnInstance.disabled = true;
            }
            if (listSecondInstance.dataSource.length) {
                fourthBtnInstance.disabled = false;
            }
            else {
                fourthBtnInstance.disabled = true;
                thirdBtnInstance.disabled = true;
            }
        }
    }
    function firstBtnClick() {
        if (listFirstInstance && firstBtnInstance && listSecondInstance) {
            listSecondInstance.dataSource = Array.prototype.concat.call(listFirstInstance.dataSource, listSecondInstance.dataSource);
            updateFirstListData();
            listFirstInstance.removeMultipleItems(listFirstInstance.liCollection);
            firstListData = firstListData.concat(listFirstInstance.dataSource);
            secondListData = listSecondInstance.dataSource.slice();
            firstBtnInstance.disabled = true;
            onFirstKeyUp(null);
            setButtonState();
        }
    }
    function secondBtnClick() {
        if (listFirstInstance && secondBtnInstance && listSecondInstance) {
            let e = listFirstInstance.getSelectedItems();
            if (e) {
                listSecondInstance.dataSource = Array.prototype.concat.call(listSecondInstance.dataSource, e.data);
                listFirstInstance.removeItem(e.item);
                firstListData = listFirstInstance.dataSource;
                secondListData = listSecondInstance.dataSource.slice();
                onFirstKeyUp(null);
                secondBtnInstance.disabled = true;
                setButtonState();
            }
        }
    }
    function thirdBtnClick() {
        if (listFirstInstance && listSecondInstance && thirdBtnInstance) {
            let e = listSecondInstance.getSelectedItems();
            if (e) {
                listFirstInstance.dataSource = Array.prototype.concat.call(listFirstInstance.dataSource, e.data);
                listSecondInstance.removeItem(e.item);
                secondListData = listSecondInstance.dataSource;
                firstListData = listFirstInstance.dataSource.slice();
                onSecondKeyUp(null);
                thirdBtnInstance.disabled = true;
                setButtonState();
            }
        }
    }
    function fourthBtnClick() {
        if (listFirstInstance && listSecondInstance && fourthBtnInstance) {
            listFirstInstance.dataSource = Array.prototype.concat.call(listFirstInstance.dataSource, listSecondInstance.dataSource);
            updateSecondListData();
            listSecondInstance.removeMultipleItems(listSecondInstance.liCollection);
            secondListData = secondListData.concat(listSecondInstance.dataSource);
            firstListData = listFirstInstance.dataSource.slice();
            onSecondKeyUp(null);
            setButtonState();
        }
    }
    function firstInputKeyUp() {
        if (listFirstInstance &&
            firstBtnInstance &&
            secondBtnInstance &&
            listSecondInstance &&
            fourthBtnInstance &&
            thirdBtnInstance &&
            firstInput) {
            let value = firstInput.value;
            var data = new DataManager(firstListData).executeLocal(new Query().where("text", "startswith", value, true));
            if (!value) {
                listFirstInstance.dataSource = firstListData.slice();
            }
            else {
                listFirstInstance.dataSource = data;
            }
            listFirstInstance.dataBind();
        }
    }
    function secondInputKeyUp() {
        if (listFirstInstance &&
            firstBtnInstance &&
            secondBtnInstance &&
            listSecondInstance &&
            fourthBtnInstance &&
            thirdBtnInstance &&
            secondInput) {
            let value = secondInput.value;
            var data = new DataManager(secondListData).executeLocal(new Query().where("text", "startswith", value, true));
            if (!value) {
                listSecondInstance.dataSource = secondListData.slice();
            }
            else {
                listSecondInstance.dataSource = data;
            }
            listSecondInstance.dataBind();
        }
    }
    return (<div id="container">
        <div className="col-lg-12 control-section">
            <div>
                <h3>Dual List</h3>
                <div id="text1">
                    <input className="e-input" type="text" id="firstInput" ref={(inputRef) => (firstInput = inputRef)} placeholder="Filter" onKeyUp={firstInputKeyUp.bind(this)} title="Type in a name" />
                </div>
                <ListViewComponent id="list-1" dataSource={firstListData} fields={fields} sortOrder="Ascending" select={onFirstListSelect.bind(this)} ref={scope => {
                    listFirstInstance = scope;
                }} />
                <div id="btn">
                    <ButtonComponent onClick={firstBtnClick.bind(this)} ref={button1 => {
                        firstBtnInstance = button1;
                    }}>
                        {" "}
                        {">>"}
                    </ButtonComponent>
                    <ButtonComponent onClick={secondBtnClick.bind(this)} ref={button2 => {
                        secondBtnInstance = button2;
                    }}>
                        {" "}
                        {">"}
                    </ButtonComponent>
                    <ButtonComponent onClick={thirdBtnClick.bind(this)} ref={button3 => {
                        thirdBtnInstance = button3;
                    }}>
                        {" "}
                        {"<"}{" "}
                    </ButtonComponent>
                    <ButtonComponent onClick={fourthBtnClick.bind(this)} ref={button4 => {
                        fourthBtnInstance = button4;
                    }}>
                        {" "}
                        {"<<"}{" "}
                    </ButtonComponent>
                </div>
                <div id="text2">
                    <input className="e-input" type="text" onKeyUp={secondInputKeyUp.bind(this)} id="secondInput" ref={(inputRef) => (secondInput = inputRef)} placeholder="  Filter" title="Type in a name" />
                </div>
                <ListViewComponent id="list-2" dataSource={secondListData} fields={fields} sortOrder="Ascending" select={onSecondListSelect.bind(this)} ref={list => {
                    listSecondInstance = list;
                }} />
            </div>
        </div>
    </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { DataManager, Query } from '@syncfusion/ej2-data';
import { enableRipple } from "@syncfusion/ej2-base";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
enableRipple(true);

function App() {
  React.useEffect(() => {
    componentDidMount();
  }, []);
  //Define an array of JSON data
  let firstListData: any[] = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" }
  ];

  let secondListData: any[] = [
    { text: "Aston Martin One- 77", id: "list-07" },
    { text: "Jaguar XJ220", id: "list-08" },
    { text: "McLaren P1", id: "list-09" },
    { text: "Ferrari LaFerrari", id: "list-10" }
  ];
  let firstInput: HTMLInputElement | null = null;
  let secondInput: HTMLInputElement | null = null;
  let listFirstInstance: ListViewComponent | null = null;
  let listSecondInstance: ListViewComponent | null = null;
  let firstBtnInstance: ButtonComponent | null = null;
  let secondBtnInstance: ButtonComponent | null = null;
  let thirdBtnInstance: ButtonComponent | null = null;
  let fourthBtnInstance: ButtonComponent | null = null;

  function componentDidMount() {
    if (listFirstInstance && listSecondInstance) {
      firstListData = (listFirstInstance.dataSource as any[]).slice();
      secondListData = (listSecondInstance.dataSource as any[]).slice();
    }
  }

  //Map the appropriate columns to fields property
  let fields: Object = { text: "text", id: "id" };

  function onFirstListSelect() {
    if (secondBtnInstance) secondBtnInstance.disabled = false;
  }

  function onSecondListSelect() {
    if (thirdBtnInstance) thirdBtnInstance.disabled = false;
  }

  function updateFirstListData() {
    if (listFirstInstance) {
      Array.prototype.forEach.call(
        (listFirstInstance as any).liCollection as any[],
        (list: any) => {
          firstListData.forEach((data, index) => {
            if (list.innerText.trim() === data.text) {
              delete firstListData[index];
            }
          });
        }
      );
      if (firstInput) {
        firstInput.value = "";
      }
      let ds: any[] = [];
      firstListData.forEach(data => {
        ds.push(data);
      });
      firstListData = ds;
    }
  }

  function updateSecondListData() {
    Array.prototype.forEach.call((listSecondInstance as any).liCollection, (list: any) => {
      secondListData.forEach((data, index) => {
        if (list.innerText.trim() === data.text) {
          delete secondListData[index];
        }
      });
    });
    if (secondInput) {
      secondInput.value = "";
    }
    let ds: any[] = [];
    secondListData.forEach(data => {
      ds.push(data);
    });
    secondListData = ds;
  }

  function onFirstKeyUp(e: any) {
    if (firstInput) {
      let value = firstInput.value;
      var data = new DataManager(firstListData).executeLocal(
        new Query().where("text", "startswith", value, true)
      );
      if (listFirstInstance) {
        if (!value) {
          listFirstInstance.dataSource = firstListData.slice();
        } else {
          listFirstInstance.dataSource = data as any[];
        }
        listFirstInstance.dataBind();
      }
    }
  }

  function onSecondKeyUp(e: any) {
    if (secondInput) {
      let value = secondInput.value;
      var data = new DataManager(secondListData).executeLocal(
        new Query().where("text", "startswith", value, true)
      );
      if (listSecondInstance) {
        if (!value) {
          listSecondInstance.dataSource = secondListData.slice();
        } else {
          listSecondInstance.dataSource = data as any[];
        }
        listSecondInstance.dataBind();
      }
    }
  }

  function setButtonState() {
    if (
      listFirstInstance &&
      firstBtnInstance &&
      secondBtnInstance &&
      listSecondInstance &&
      fourthBtnInstance &&
      thirdBtnInstance
    ) {
      if ((listFirstInstance.dataSource as any[]).length) {
        firstBtnInstance.disabled = false;
      } else {
        firstBtnInstance.disabled = true;
        secondBtnInstance.disabled = true;
      }

      if ((listSecondInstance.dataSource as any[]).length) {
        fourthBtnInstance.disabled = false;
      } else {
        fourthBtnInstance.disabled = true;
        thirdBtnInstance.disabled = true;
      }
    }
  }

  function firstBtnClick() {
    if (listFirstInstance && firstBtnInstance && listSecondInstance) {
      listSecondInstance.dataSource = Array.prototype.concat.call(
        listFirstInstance.dataSource,
        listSecondInstance.dataSource
      );
      updateFirstListData();
      listFirstInstance.removeMultipleItems((listFirstInstance as any).liCollection);
      firstListData = firstListData.concat(listFirstInstance.dataSource);
      secondListData = listSecondInstance.dataSource.slice();
      firstBtnInstance.disabled = true;
      onFirstKeyUp(null);
      setButtonState();
    }
  }

  function secondBtnClick() {
    if (listFirstInstance && secondBtnInstance && listSecondInstance) {
      let e = listFirstInstance.getSelectedItems();
      if (e) {
        listSecondInstance.dataSource = Array.prototype.concat.call(
          listSecondInstance.dataSource,
          e.data
        );
        listFirstInstance.removeItem(e.item as any);
        firstListData = listFirstInstance.dataSource as any[];
        secondListData = listSecondInstance.dataSource.slice();
        onFirstKeyUp(null);
        secondBtnInstance.disabled = true;
        setButtonState();
      }
    }
  }

  function thirdBtnClick() {
    if (listFirstInstance && listSecondInstance && thirdBtnInstance) {
      let e = listSecondInstance.getSelectedItems();
      if (e) {
        listFirstInstance.dataSource = Array.prototype.concat.call(
          listFirstInstance.dataSource,
          e.data
        );
        listSecondInstance.removeItem(e.item as any);
        secondListData = listSecondInstance.dataSource as any[];
        firstListData = listFirstInstance.dataSource.slice();
        onSecondKeyUp(null);
        thirdBtnInstance.disabled = true;
        setButtonState();
      }
    }
  }

  function fourthBtnClick() {
    if (listFirstInstance && listSecondInstance && fourthBtnInstance) {
      listFirstInstance.dataSource = Array.prototype.concat.call(
        listFirstInstance.dataSource,
        listSecondInstance.dataSource
      );
      updateSecondListData();
      listSecondInstance.removeMultipleItems((listSecondInstance as any).liCollection);
      secondListData = secondListData.concat(listSecondInstance.dataSource);
      firstListData = listFirstInstance.dataSource.slice();
      onSecondKeyUp(null);
      setButtonState();
    }
  }

  function firstInputKeyUp() {
    if (
      listFirstInstance &&
      firstBtnInstance &&
      secondBtnInstance &&
      listSecondInstance &&
      fourthBtnInstance &&
      thirdBtnInstance &&
      firstInput
    ) {
      let value = firstInput.value;
      var data = new DataManager(firstListData).executeLocal(
        new Query().where("text", "startswith", value, true)
      );
      if (!value) {
        listFirstInstance.dataSource = firstListData.slice();
      } else {
        listFirstInstance.dataSource = data as any[];
      }
      listFirstInstance.dataBind();
    }
  }

  function secondInputKeyUp() {
    if (
      listFirstInstance &&
      firstBtnInstance &&
      secondBtnInstance &&
      listSecondInstance &&
      fourthBtnInstance &&
      thirdBtnInstance &&
      secondInput
    ) {
      let value = secondInput.value;
      var data = new DataManager(secondListData).executeLocal(
        new Query().where("text", "startswith", value, true)
      );
      if (!value) {
        listSecondInstance.dataSource = secondListData.slice();
      } else {
        listSecondInstance.dataSource = data as any[];
      }
      listSecondInstance.dataBind();
    }
  }

  return (
    <div id="container">
      <div className="col-lg-12 control-section">
        <div>
          <h3>Dual List</h3>
          <div id="text1">
            <input
              className="e-input"
              type="text"
              id="firstInput"
              ref={(inputRef: any) => (firstInput = inputRef)}
              placeholder="Filter"
              onKeyUp={firstInputKeyUp.bind(this)}
              title="Type in a name"
            />
          </div>
          <ListViewComponent
            id="list-1"
            dataSource={firstListData}
            fields={fields}
            sortOrder="Ascending"
            select={onFirstListSelect.bind(this)}
            ref={scope => {
              listFirstInstance = scope;
            }}
          />
          <div id="btn">
            <ButtonComponent
              onClick={firstBtnClick.bind(this)}
              ref={button1 => {
                firstBtnInstance = button1;
              }}
            >
              {" "}
              {">>"}
            </ButtonComponent>
            <ButtonComponent
              onClick={secondBtnClick.bind(this)}
              ref={button2 => {
                secondBtnInstance = button2;
              }}
            >
              {" "}
              {">"}
            </ButtonComponent>
            <ButtonComponent
              onClick={thirdBtnClick.bind(this)}
              ref={button3 => {
                thirdBtnInstance = button3;
              }}
            >
              {" "}
              {"<"}{" "}
            </ButtonComponent>
            <ButtonComponent
              onClick={fourthBtnClick.bind(this)}
              ref={button4 => {
                fourthBtnInstance = button4;
              }}
            >
              {" "}
              {"<<"}{" "}
            </ButtonComponent>
          </div>
          <div id="text2">
            <input
              className="e-input"
              type="text"
              onKeyUp={secondInputKeyUp.bind(this)}
              id="secondInput"
              ref={(inputRef: any) => (secondInput = inputRef)}
              placeholder="  Filter"
              title="Type in a name"
            />
          </div>
          <ListViewComponent
            id="list-2"
            dataSource={secondListData}
            fields={fields}
            sortOrder="Ascending"
            select={onSecondListSelect.bind(this)}
            ref={list => {
              listSecondInstance = list;
            }}
          />
        </div>
      </div>
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    font-family: 'Helvetica Neue', 'calibiri';
    font-size: 14px;
    top: 45%;
    left: 45%;
}

#list-1,
#list-2 {
    width: 40%;
    height: 430px;
    box-shadow: 0 1px 4px #ddd;
    border-bottom: 1px solid #ddd;
}

#firstList,
#secondList {
    margin-top: 13px;
}

.e-btn {
    width: 60px;
    height: 60px;
    margin-bottom: 15px;
}

#btn {
    float: left;
    width: 5%;
    padding-left: 20px;
    margin-top: 67px;
}

#list-1 {
    float: left;
}

#list-2 {
    float: right;
}

#firstInput {
    width: 40%;
}

#secondInput {
    width: 52%;
    margin-left: 14%;
}

#text2 {
    margin-top: -30px;
    margin-left: 115px;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:500px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Syncfusion AI Assistant

How can I help you?

Create dual list from ListView in Angular ListView component

10 Sep 202521 minutes to read

A dual list interface consists of two ListView components that enable users to transfer items between two collections through intuitive controls. This pattern is commonly used for selection scenarios where users need to move items from an available list to a selected list and vice versa. The ListView component provides robust support for implementing dual list functionality with built-in events and data manipulation capabilities.

Use cases

Dual list interfaces are particularly effective for:

  • Stock exchanges management: Moving stocks between different country portfolios or market categories
  • Job application systems: Transferring skills between available competencies and selected qualifications
  • User permission management: Assigning and removing user roles or access rights
  • Product catalog organization: Moving products between different categories or collections
  • Resource allocation: Distributing resources between available and assigned pools

Integration of Dual List

The dual list implementation uses two ListView components positioned side-by-side with transfer controls between them. An ej2-button component provides the transfer functionality, while a TextBox enables filtering capabilities for improved user experience with large datasets.

The dual list architecture supports:

  • Bulk transfer operations: Moving entire datasets from one list to another
  • Selective item transfer: Moving individually selected items between lists
  • Real-time filtering: Dynamically filtering list content based on user input
  • Bidirectional data flow: Supporting transfers in both directions with appropriate validation

In the ListView component, sorting is enabled using the sortOrder property to maintain consistent item ordering across transfers. The select event triggers when users interact with items, enabling dynamic button state management and transfer validation.

Data Transfer Operations

Moving complete dataset from first to second list (»)

The bulk forward transfer moves all items from the source ListView to the destination ListView. When users click the forward button, the system extracts all items from the first list using array slicing operations and concatenates them with the second ListView’s existing data. This button remains active only when the source ListView contains data, preventing unnecessary operations on empty collections.

Moving complete dataset from second to first list («)

The bulk backward transfer operates identically to the forward transfer but moves data from the second ListView back to the first. This operation maintains data integrity by transferring all items while preserving their original structure and sorting order. The button activation depends on the second ListView containing transferable items.

Moving selected items between lists (>) and (<)

Individual item transfers rely on the ListView’s select event to identify user-chosen items. When users select specific items from either list, the corresponding transfer buttons become active, allowing precise control over which items move between collections. This selective approach provides granular control while maintaining the overall list organization.

Filtering Implementation

The filtering functionality uses a TextBox input to capture user queries and dynamically filter ListView content. The implementation leverages the dataManager to query the underlying data source, applying text-based filters that update the ListView display in real-time. This approach ensures efficient data handling while providing responsive user feedback during filtering operations.

Sorting Behavior

List item sorting in dual list implementations uses the ListView’s sortOrder property to maintain consistent ordering across both components. When sorting is enabled in one ListView, transferred items retain the same sort order in the destination list, ensuring data consistency and predictable user experience throughout the transfer process.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ListViewModule } from '@syncfusion/ej2-angular-lists'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { Component, ViewChild } from "@angular/core";
import { enableRipple } from "@syncfusion/ej2-base";
import { DataManager, Query, ODataV4Adaptor } from "@syncfusion/ej2-data";
import { ListViewComponent } from "@syncfusion/ej2-angular-lists";
import { ButtonComponent } from "@syncfusion/ej2-angular-buttons"
enableRipple(true);

@Component({
    imports: [
        ListViewModule, ButtonModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `<div id="text1">
        <input #textbox class="e-input" type="text" id="firstInput" placeholder="Filter" title="Type in a name" (keyup)="onFirstKeyUp($event)" />
            </div>
        <ejs-listview #list1 id='list-1' [dataSource]='firstListData' [fields]='fields' [sortOrder]='Ascending'  (select)="onFirstListSelect()"></ejs-listview>
            <div id="btn">
            <button ejs-button #btn1 id="firstBtn" (click)="firstbtnclick()"> >> </button>
            <button ejs-button #btn2 id="secondBtn" [disabled]=true (click)="secondbtnclick()"> > </button>
            <button ejs-button #btn3 id="thirdBtn" [disabled]=true (click)="thirdbtnclick()"> < </button>
            <button ejs-button #btn4 id="fourthBtn" (click)="fourthbtnclick()"> << </button>
            </div>

        <div id="text2">
        <input #text class="e-input" type="text" id="secondInput" placeholder="Filter" title="Type in a name" (keyup)="onSecondKeyUp($event)" />
        </div>
        <ejs-listview #list2 id='list-2' [dataSource]='secondListData' [fields]='fields' [sortOrder]='Ascending' (select)="onSecondListSelect()"></ejs-listview>`,
})

export class AppComponent {
    public fields?: Object;
    public firstListData?: any; secondListData: any;
    Ascending: any;
    constructor() {
        this.firstListData = [
            { text: "Hennessey Venom", id: "list-01" },
            { text: "Bugatti Chiron", id: "list-02" },
            { text: "Bugatti Veyron Super Sport", id: "list-03" },
            { text: "SSC Ultimate Aero", id: "list-04" },
            { text: "Koenigsegg CCR", id: "list-05" },
            { text: "McLaren F1", id: "list-06" }
        ];

        this.secondListData = [
            { text: 'Aston Martin One- 77', id: 'list-07' },
            { text: 'Jaguar XJ220', id: 'list-08' },
            { text: 'McLaren P1', id: 'list-09' },
            { text: 'Ferrari LaFerrari', id: 'list-10' },
        ];

        this.fields = { text: "text", id: "id" };
    }
    @ViewChild('list1') firstListObj?: ListViewComponent;
    @ViewChild('list2') secondListObj?: ListViewComponent;
    @ViewChild('btn1') firstBtnObj?: ButtonComponent;
    @ViewChild('btn2') secondBtnObj?: ButtonComponent;
    @ViewChild('btn3') thirdBtnObj?: ButtonComponent;
    @ViewChild('btn4') fourthBtnObj?: ButtonComponent;
    @ViewChild('textbox') textboxEle: any;
    @ViewChild('text') textEle: any;
    ngAfterViewInit() {
        this.firstListData = (this.firstListObj as ListViewComponent | any).dataSource.slice();
        this.secondListData = (this.secondListObj as ListViewComponent | any).dataSource.slice();
    }
    //Here, all list items are moved to the second list on clicking move all button
    firstbtnclick() {
        (this.secondListObj as ListViewComponent).dataSource = Array.prototype.concat.call((this.firstListObj as ListViewComponent).dataSource, (this.secondListObj as ListViewComponent).dataSource);
        this.updateFirstListData();
        this.firstListObj?.removeMultipleItems((this.firstListObj as ListViewComponent | any).liCollection);
        this.firstListData = this.firstListData.concat((this.firstListObj as ListViewComponent).dataSource);
        this.secondListData = (this.secondListObj as ListViewComponent | any).dataSource.slice();
        (this.firstBtnObj as ButtonComponent).disabled = true;
        this.onFirstKeyUp((e: any) => { });;
        this.setButtonState();
    }

    //Here, the selected list items are moved to the second list on clicking move button
    secondbtnclick() {
        let e = this.firstListObj?.getSelectedItems();
        (this.secondListObj as ListViewComponent).dataSource = Array.prototype.concat.call((this.secondListObj as ListViewComponent).dataSource, (e as any).data);
        this.firstListObj?.removeItem((e as any).item);
        this.firstListData = (this.firstListObj as ListViewComponent).dataSource;
        this.secondListData = (this.secondListObj as ListViewComponent | any).dataSource.slice();
        this.onFirstKeyUp((e: any) => { });;
        (this.secondBtnObj as ButtonComponent).disabled = true;
        this.setButtonState();
    }

    //Here, the selected list items are moved to the first list on clicking move button
    thirdbtnclick() {
        let e = this.secondListObj?.getSelectedItems();
        (this.firstListObj as ListViewComponent).dataSource = Array.prototype.concat.call((this.firstListObj as ListViewComponent).dataSource, (e as any).data);
        this.secondListObj?.removeItem((e as any).item);
        this.secondListData = (this.secondListObj as ListViewComponent).dataSource;
        this.firstListData = (this.firstListObj as ListViewComponent | any).dataSource.slice();
        this.onSecondKeyUp((e: any) => { });
        (this.thirdBtnObj as ButtonComponent).disabled = true;
        this.setButtonState();

    }

    //Here, all list items are moved to the first list on clicking move all button
    fourthbtnclick() {
        (this.firstListObj as ListViewComponent).dataSource = Array.prototype.concat.call((this.firstListObj as ListViewComponent).dataSource, (this.secondListObj as ListViewComponent).dataSource);
        this.updateSecondListData();
        this.secondListObj?.removeMultipleItems((this.secondListObj as ListViewComponent | any).liCollection);
        this.secondListData = this.secondListData.concat((this.secondListObj as ListViewComponent).dataSource);
        this.firstListData = (this.firstListObj as ListViewComponent | any).dataSource.slice();
        this.onSecondKeyUp((e: any) => { });
        this.setButtonState();

    }

    //Here, the ListView data source is updated to the first list
    updateFirstListData() {
        Array.prototype.forEach.call((this.firstListObj as ListViewComponent | any).liCollection, (list) => {
            this.firstListData.forEach((data: any, index: any) => {
                if (list.innerText.trim() === data.text) {
                    delete this.firstListData[index];
                }
            });
        });
        this.textboxEle.nativeElement.value = '';
        let ds: any[] = [];
        this.firstListData.forEach((data: any) => {
            ds.push(data);
        })
        this.firstListData = ds;

    }

    //Here, the ListView dataSource is updated for the second list
    updateSecondListData() {
        Array.prototype.forEach.call((this.secondListObj as ListViewComponent | any).liCollection, (list) => {
            this.secondListData.forEach((data: any, index: string | number) => {
                if (list.innerText.trim() === data.text) {
                    delete this.secondListData[index];
                }
            });

        });
        this.textEle.nativeElement.value = '';
        let ds: any = [];
        this.secondListData.forEach((data: any) => {
            ds.push(data);
        })
        this.secondListData = ds;

    }
    onFirstListSelect() {
        (this.secondBtnObj as ButtonComponent).disabled = false;
    }
    onSecondListSelect() {
        (this.thirdBtnObj as ButtonComponent).disabled = false;
    }

    //Here, filtering is handled using the dataManager for the first list
    onFirstKeyUp(e: any) {
        let value = this.textboxEle.nativeElement.value;
        let data = new DataManager(this.firstListData).executeLocal(new Query().where('text', 'startswith', value, true));
        if (!value) {
            (this.firstListObj as ListViewComponent).dataSource = this.firstListData.slice();
        } else {
            (this.firstListObj as ListViewComponent | any).dataSource = data;
        }
    }
    //Here, filtering is handled using the dataManager for the second list
    onSecondKeyUp(e: any) {
        let value = this.textEle.nativeElement.value;
        let data = new DataManager(this.secondListData).executeLocal(new Query().where('text', 'startswith', value, true));
        if (!value) {
            (this.secondListObj as ListViewComponent).dataSource = this.secondListData.slice();
        } else {
            (this.secondListObj as ListViewComponent | any).dataSource = data;
        }
    }

    //Here, the state of the button is changed
    setButtonState() {
        if ((this.firstListObj as ListViewComponent | any).dataSource.length) {
            (this.firstBtnObj as ButtonComponent).disabled = false;
        } else {
            (this.firstBtnObj as ButtonComponent).disabled = true;
            (this.secondBtnObj as ButtonComponent).disabled = true;
        }

        if ((this.secondListObj as ListViewComponent | any).dataSource.length) {
            (this.fourthBtnObj as ButtonComponent).disabled = false;
        } else {
            (this.fourthBtnObj as ButtonComponent).disabled = true;
            (this.thirdBtnObj as ButtonComponent).disabled = true;
        }

    }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material3.css';

#list-1,
#list-2 {
    width: 40%;
    height: 430px;
    box-shadow: 0 1px 4px #ddd;
    border-bottom: 1px solid #ddd;
}

#firstList,
#secondList {
    margin-top: 13px;
}

.e-btn {
    width: 60px;
    height: 60px;
    margin-bottom: 15px;
}

#btn {
    float: left;
    width: 5%;
    padding-left: 30px;
    margin-top: 67px;
}

#list-1 {
    float: left;
}

#list-2 {
    float: right;
}

#firstInput {
    width: 40%;
}

#secondInput {
    margin-left: 102px;
    width: 51.4%;
}

#text2 {
    margin-top: -23px;
    margin-left: 194px;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Syncfusion AI Assistant

How can I help you?

Create dual list from ListView in Vue ListView component

21 Feb 202524 minutes to read

The dual list contains two ListViews. This allows you to move list items from one list to another using client-side events. This section explains how to integrate the ListView component to achieve dual list.

Use cases

  • Stock exchanges of two different countries
  • Job applications (skill sets)

Integration of Dual List

Here, two ListView components have been used to display the list items. An ej2-button is used to transfer data between the ListViews, and a textbox is used to implement filtering support.

The dual list supports:

  • Moving whole data from one list to another.
  • Moving selected data from one list to another.
  • Filtering the list by using a client-side typed character.

In the ListView component, sorting is enabled using the sortOrder property, and the select event is triggered while selecting an item. Here, the select event is triggered to enable and disable button states.

Manipulating data

Moving whole data from the first list to the second list(»)

  • Here, the whole data can be moved from the first ListView to the second by clicking the first button. When clicking the button, all list items are sliced and concatenated with the second ListView. This button is enabled only when the data source of the first ListView is not empty.

Moving whole data from the second list to the first list(«)

  • The functionality of the second button is the same as above, and data is transferred from the second list to the first list. This button is enabled only when the data source of the second ListView is not empty.

Moving selected item from one list to another list (>) and (<)

  • The Select event is triggered when selecting a list item in the ListView. The selected items can be transferred between two lists. These buttons will be enabled when selecting an item in lists.

Filtering method

  • The filtering method is used to filter list items when typing a character in the text box. In this method, the dataManager is used to fetch data from the data source and display it in the ListView.

Sorting

  • By using the dual list, list items can be sorted in the ListView component using the sortOrder property. You can enable sorting in one ListView, and the data will be transferred to the other ListView in the same order.
<template>
    <div>
      <div id="text1">
        <input ref='textboxEle' class="e-input" type="text" id="firstInput" placeholder="Filter" title="Type in a name"
          @keyup="onFirstKeyUp" />
      </div>
      <ejs-listview ref='firstListObj' id='list-1' :dataSource='firstListData' :fields='fields' sortOrder='Ascending'
        :select="onFirstListSelect"></ejs-listview>
      <div id="btn">
        <ejs-button ref='firstBtnObj' id="firstBtn" @click="firstbtnclick"> &gt;&gt; </ejs-button>
        <ejs-button ref='secondBtnObj' id="secondBtn" :disabled='disabled' @click="secondbtnclick"> &gt; </ejs-button>
        <ejs-button ref='thirdBtnObj' id="thirdBtn" :disabled='disabled' @click="thirdbtnclick"> &lt; </ejs-button>
        <ejs-button ref='fourthBtnObj' id="fourthBtn" @click="fourthbtnclick"> &lt;&lt; </ejs-button>
      </div>
  
      <div id="text2">
        <input ref='textEle' class="e-input" type="text" id="secondInput" placeholder="Filter" title="Type in a name"
          @keyup="onSecondKeyUp" />
      </div>
      <ejs-listview ref='secondListObj' id='list-2' :dataSource='secondListData' :fields='fields' sortOrder='Ascending'
        :select="onSecondListSelect"></ejs-listview>
    </div>
  </template>
  
  <script setup>
  
  import { ListViewComponent as EjsListview } from "@syncfusion/ej2-vue-lists";
  import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
  import { enableRipple } from '@syncfusion/ej2-base';
  import { DataManager, Query } from "@syncfusion/ej2-data";
  import { onMounted, ref } from 'vue';
  
  enableRipple(true);
  
  
  const textboxEle = ref(null);
  const textEle = ref(null);
  const firstListObj = ref(null);
  const secondListObj = ref(null);
  const firstBtnObj = ref(null);
  const secondBtnObj = ref(null);
  const thirdBtnObj = ref(null);
  const fourthBtnObj = ref(null);
  
  let firstListData = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" }
  ];
  let secondListData = [
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  const fields = { text: "text", id: "id" };
  const disabled = true;
  
  onMounted(() => {
    firstListData = firstListObj.value.ej2Instances.dataSource.slice();
    secondListData = secondListObj.value.ej2Instances.dataSource.slice();
  });
  
  const firstbtnclick = () => {
    secondListObj.value.ej2Instances.dataSource = Array.prototype.concat.call(firstListObj.value.ej2Instances.dataSource, secondListObj.value.ej2Instances.dataSource);
    secondListObj.value.ej2Instances.dataBind();
    updateFirstListData();
    firstListObj.value.ej2Instances.removeMultipleItems(firstListObj.value.$el.ej2_instances[0].liCollection);
    firstListData = firstListData.concat(firstListObj.value.ej2Instances.dataSource);
    secondListData = secondListObj.value.ej2Instances.dataSource.slice();
    firstBtnObj.value.$el.disabled = true;
    onFirstKeyUp();
    setButtonState();
  };
  
  const secondbtnclick = () => {   //Here, the selected list items are moved to the second list on clicking move button
    let e = firstListObj.value.ej2Instances.getSelectedItems();
    secondListObj.value.ej2Instances.dataSource = Array.prototype.concat.call(secondListObj.value.ej2Instances.dataSource, e.data);
    firstListObj.value.ej2Instances.removeItem(e.item);
    firstListData = firstListObj.value.ej2Instances.dataSource;
    secondListData = secondListObj.value.ej2Instances.dataSource.slice();
    onFirstKeyUp();
    secondBtnObj.value.$el.disabled = true;
    setButtonState();
  }
  
  const thirdbtnclick = () => {  //Here, the selected list items are moved to the first list on clicking move button
    let e = secondListObj.value.ej2Instances.getSelectedItems();
    firstListObj.value.ej2Instances.dataSource = Array.prototype.concat.call(firstListObj.value.ej2Instances.dataSource, e.data);
    secondListObj.value.ej2Instances.removeItem(e.item);
    secondListData = secondListObj.value.ej2Instances.dataSource;
    firstListData = firstListObj.value.ej2Instances.dataSource.slice();
    onSecondKeyUp();
    thirdBtnObj.value.$el.disabled = true;
    setButtonState();
  };
  
  const fourthbtnclick = () => {   //Here, all list items are moved to the first list on clicking move all button
    firstListObj.value.ej2Instances.dataSource = Array.prototype.concat.call(firstListObj.value.ej2Instances.dataSource, secondListObj.value.ej2Instances.dataSource);
    updateSecondListData();
    secondListObj.value.ej2Instances.removeMultipleItems(secondListObj.value.$el.ej2_instances[0].liCollection);
    secondListData = secondListData.concat(secondListObj.value.ej2Instances.dataSource);
    firstListData = firstListObj.value.ej2Instances.dataSource.slice();
    onSecondKeyUp();
    setButtonState();
  
  };
  
  const updateFirstListData = () => {  //Here, the ListView data source is updated to the first list
    Array.prototype.forEach.call(firstListObj.value.$el.ej2_instances[0].liCollection, (list) => {
      firstListData.forEach((data, index) => {
        if (list.innerText.trim() === data.text) {
          firstListData.splice(index, 1)
        }
      });
    });
    textboxEle.value = '';
    let ds = [];
    firstListData.forEach((data) => {
      ds.push(data);
    });
    firstListData = ds;
  
  };
  
  //Here, the ListView dataSource is updated for the second list
  const updateSecondListData = () => {
    Array.prototype.forEach.call(secondListObj.value.$el.ej2_instances[0].liCollection, (list) => {
      secondListData.forEach((data, index) => {
        if (list.innerText.trim() === data.text) {
          secondListData.splice(index, 1);
        }
      });
    });
    textEle.value = '';
    let ds = [];
    secondListData.forEach((data) => {
      ds.push(data);
    });
    secondListData = ds;
  };
  const onFirstListSelect = () => {
    secondBtnObj.value.$el.disabled = false;
  };
  const onSecondListSelect = () => {
    thirdBtnObj.value.$el.disabled = false;
  };
  //Here, filtering is handled using the dataManager for the first list
  const onFirstKeyUp = () => {
    let value = textboxEle.value.value;
    let data = new DataManager(firstListData).executeLocal(new Query().where('text', 'startswith', value, true));
    if (!value) {
      firstListObj.value.ej2Instances.dataSource = firstListData.slice();
    } else {
      firstListObj.value.ej2Instances.dataSource = data;
    }
  }
  //Here, filtering is handled using the dataManager for the second list
  const onSecondKeyUp = () => {
    let value = textEle.value.value;
    let data = new DataManager(secondListData).executeLocal(new Query().where('text', 'startswith', value, true));
    if (!value) {
      secondListObj.value.ej2Instances.dataSource = secondListData.slice();
    } else {
      secondListObj.value.ej2Instances.dataSource = data;
    }
  };
  //Here, the state of the button is changed
  const setButtonState = () => {
    if (firstListObj.value.ej2Instances.dataSource.length) {
      firstBtnObj.value.$el.disabled = false;
    } else {
      firstBtnObj.value.$el.disabled = true;
      secondBtnObj.value.$el.disabled = true;
    }
  
    if (secondListObj.value.ej2Instances.dataSource.length) {
      fourthBtnObj.value.$el.disabled = false;
    } else {
      fourthBtnObj.value.$el.disabled = true;
      thirdBtnObj.value.$el.disabled = true;
    }
  
  };
  
  
  </script>
  
  <style>
  #list-1,
  #list-2 {
    width: 40%;
    height: 430px;
    box-shadow: 0 1px 4px #ddd;
    border-bottom: 1px solid #ddd;
  }
  
  #firstList,
  #secondList {
    margin-top: 13px;
  }
  
  .e-btn {
    width: 60px;
    height: 60px;
    margin-bottom: 15px;
  }
  
  #btn {
    float: left;
    width: 5%;
    padding-left: 30px;
    margin-top: 67px;
  }
  
  #list-1 {
    float: left;
  }
  
  #list-2 {
    float: right;
  }
  
  #firstInput {
    width: 40%;
  }
  
  #secondInput {
    margin-left: 102px;
    width: 51.4%;
  }
  
  #text2 {
    margin-top: -23px;
    margin-left: 194px;
  }
  </style>
<template>
    <div>
        <div id="text1">
            <input ref='textboxEle' class="e-input" type="text" id="firstInput" placeholder="Filter"
                title="Type in a name" @keyup="onFirstKeyUp" />
        </div>
        <ejs-listview ref='firstListObj' id='list-1' :dataSource='firstListData' :fields='fields' sortOrder='Ascending'
            :select="onFirstListSelect"></ejs-listview>
        <div id="btn">
            <ejs-button ref='firstBtnObj' id="firstBtn" @click="firstbtnclick"> &gt;&gt; </ejs-button>
            <ejs-button ref='secondBtnObj' id="secondBtn" :disabled='disabled' @click="secondbtnclick"> &gt;
            </ejs-button>
            <ejs-button ref='thirdBtnObj' id="thirdBtn" :disabled='disabled' @click="thirdbtnclick"> &lt; </ejs-button>
            <ejs-button ref='fourthBtnObj' id="fourthBtn" @click="fourthbtnclick"> &lt;&lt; </ejs-button>
        </div>

        <div id="text2">
            <input ref='textEle' class="e-input" type="text" id="secondInput" placeholder="Filter"
                title="Type in a name" @keyup="onSecondKeyUp" />
        </div>
        <ejs-listview ref='secondListObj' id='list-2' :dataSource='secondListData' :fields='fields'
            sortOrder='Ascending' :select="onSecondListSelect"></ejs-listview>
    </div>
</template>

<script>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
import { enableRipple } from '@syncfusion/ej2-base';
import { DataManager, Query } from "@syncfusion/ej2-data";
enableRipple(true);




export default {
    name: "App",
    components: {
        "ejs-listview": ListViewComponent,
        "ejs-button": ButtonComponent
    },

    data: function () {
        return {
            firstListData: [
                { text: "Hennessey Venom", id: "list-01" },
                { text: "Bugatti Chiron", id: "list-02" },
                { text: "Bugatti Veyron Super Sport", id: "list-03" },
                { text: "SSC Ultimate Aero", id: "list-04" },
                { text: "Koenigsegg CCR", id: "list-05" },
                { text: "McLaren F1", id: "list-06" }
            ],
            secondListData: [
                { text: 'Aston Martin One- 77', id: 'list-07' },
                { text: 'Jaguar XJ220', id: 'list-08' },
                { text: 'McLaren P1', id: 'list-09' },
                { text: 'Ferrari LaFerrari', id: 'list-10' },
            ],
            fields: { text: "text", id: "id" },
            disabled: true
        };
    },
    mounted: function () {
        this.firstListData = this.$refs.firstListObj.ej2Instances.dataSource.slice();
        this.secondListData = this.$refs.secondListObj.ej2Instances.dataSource.slice();
    },
    methods: {
        firstbtnclick: function () {
            this.$refs.secondListObj.ej2Instances.dataSource = Array.prototype.concat.call(this.$refs.firstListObj.ej2Instances.dataSource, this.$refs.secondListObj.ej2Instances.dataSource);
            this.$refs.secondListObj.ej2Instances.dataBind();
            this.updateFirstListData();
            this.$refs.firstListObj.ej2Instances.removeMultipleItems(this.$refs.firstListObj.$el.ej2_instances[0].liCollection);
            this.firstListData = this.firstListData.concat(this.$refs.firstListObj.ej2Instances.dataSource);
            this.secondListData = this.$refs.secondListObj.ej2Instances.dataSource.slice();
            this.$refs.firstBtnObj.$el.disabled = true;
            this.onFirstKeyUp();
            this.setButtonState();
        },

        secondbtnclick: function () {   //Here, the selected list items are moved to the second list on clicking move button
            let e = this.$refs.firstListObj.ej2Instances.getSelectedItems();
            this.$refs.secondListObj.ej2Instances.dataSource = Array.prototype.concat.call(this.$refs.secondListObj.ej2Instances.dataSource, e.data);
            this.$refs.firstListObj.ej2Instances.removeItem(e.item);
            this.firstListData = this.$refs.firstListObj.ej2Instances.dataSource;
            this.secondListData = this.$refs.secondListObj.ej2Instances.dataSource.slice();
            this.onFirstKeyUp();
            this.$refs.secondBtnObj.$el.disabled = true;
            this.setButtonState();
        },

        thirdbtnclick: function () {  //Here, the selected list items are moved to the first list on clicking move button
            let e = this.$refs.secondListObj.ej2Instances.getSelectedItems();
            this.$refs.firstListObj.ej2Instances.dataSource = Array.prototype.concat.call(this.$refs.firstListObj.ej2Instances.dataSource, e.data);
            this.$refs.secondListObj.ej2Instances.removeItem(e.item);
            this.secondListData = this.$refs.secondListObj.ej2Instances.dataSource;
            this.firstListData = this.$refs.firstListObj.ej2Instances.dataSource.slice();
            this.onSecondKeyUp();
            this.$refs.thirdBtnObj.$el.disabled = true;
            this.setButtonState();

        },

        fourthbtnclick: function () {   //Here, all list items are moved to the first list on clicking move all button
            this.$refs.firstListObj.ej2Instances.dataSource = Array.prototype.concat.call(this.$refs.firstListObj.ej2Instances.dataSource, this.$refs.secondListObj.ej2Instances.dataSource);
            this.updateSecondListData();
            this.$refs.secondListObj.ej2Instances.removeMultipleItems(this.$refs.secondListObj.$el.ej2_instances[0].liCollection);
            this.secondListData = this.secondListData.concat(this.$refs.secondListObj.ej2Instances.dataSource);
            this.firstListData = this.$refs.firstListObj.ej2Instances.dataSource.slice();
            this.onSecondKeyUp();
            this.setButtonState();
        },

        updateFirstListData: function () {  //Here, the ListView data source is updated to the first list
            Array.prototype.forEach.call(this.$refs.firstListObj.$el.ej2_instances[0].liCollection, (list) => {
                this.firstListData.forEach((data, index) => {
                    if (list.innerText.trim() === data.text) {
                        this.firstListData.splice(index, 1)
                    }
                });
            });
            this.$refs.textboxEle.value = '';
            let ds = [];
            this.firstListData.forEach((data) => {
                ds.push(data);
            });
            this.firstListData = ds;

        },

        //Here, the ListView dataSource is updated for the second list
        updateSecondListData: function () {
            Array.prototype.forEach.call(this.$refs.secondListObj.$el.ej2_instances[0].liCollection, (list) => {
                this.secondListData.forEach((data, index) => {
                    if (list.innerText.trim() === data.text) {
                        this.secondListData.splice(index, 1);
                    }
                });
            });
            this.$refs.textEle.value = '';
            let ds = [];
            this.secondListData.forEach((data) => {
                ds.push(data);
            });
            this.secondListData = ds;

        },
        onFirstListSelect: function () {
            this.$refs.secondBtnObj.$el.disabled = false;
        },
        onSecondListSelect: function () {
            this.$refs.thirdBtnObj.$el.disabled = false;
        },
        //Here, filtering is handled using the dataManager for the first list
        onFirstKeyUp: function () {
            let value = this.$refs.textboxEle.value;
            let data = new DataManager(this.firstListData).executeLocal(new Query().where('text', 'startswith', value, true));
            if (!value) {
                this.$refs.firstListObj.ej2Instances.dataSource = this.firstListData.slice();
            } else {
                this.$refs.firstListObj.ej2Instances.dataSource = data;
            }
        },
        //Here, filtering is handled using the dataManager for the second list
        onSecondKeyUp: function () {
            let value = this.$refs.textEle.value;
            let data = new DataManager(this.secondListData).executeLocal(new Query().where('text', 'startswith', value, true));
            if (!value) {
                this.$refs.secondListObj.ej2Instances.dataSource = this.secondListData.slice();
            } else {
                this.$refs.secondListObj.ej2Instances.dataSource = data;
            }
        },
        //Here, the state of the button is changed
        setButtonState: function () {
            if (this.$refs.firstListObj.ej2Instances.dataSource.length) {
                this.$refs.firstBtnObj.$el.disabled = false;
            } else {
                this.$refs.firstBtnObj.$el.disabled = true;
                this.$refs.secondBtnObj.$el.disabled = true;
            }

            if (this.$refs.secondListObj.ej2Instances.ej2Instances.dataSource.length) {
                this.$refs.fourthBtnObj.$el.disabled = false;
            } else {
                this.$refs.fourthBtnObj.$el.disabled = true;
                this.$refs.thirdBtnObj.$el.disabled = true;
            }

        }
    }
}
</script>
<style>
#list-1,
#list-2 {
    width: 40%;
    height: 430px;
    box-shadow: 0 1px 4px #ddd;
    border-bottom: 1px solid #ddd;
}

#firstList,
#secondList {
    margin-top: 13px;
}

.e-btn {
    width: 60px;
    height: 60px;
    margin-bottom: 15px;
}

#btn {
    float: left;
    width: 5%;
    padding-left: 30px;
    margin-top: 67px;
}

#list-1 {
    float: left;
}

#list-2 {
    float: right;
}

#firstInput {
    width: 40%;
}

#secondInput {
    margin-left: 102px;
    width: 51.4%;
}

#text2 {
    margin-top: -23px;
    margin-left: 194px;
}
</style>